import QtQuick 1.1
import com.nokia.meego 1.0

Item {
    id: rootapple

    //cut the fruit - part[1]
    Image {
        id: apple_1
        source: "images/apple-h1.png"
        smooth: true
        visible: false
        anchors.bottom: apple.bottom
        anchors.right:apple.right
        anchors.rightMargin: Math.floor(Math.random()*30+30)

        NumberAnimation on rotation { id: rx; from: 0; to: 360; duration: Math.floor(Math.random()*3000+600); loops: Animation.Infinite }
    }

    //cut the fruit - part[2]
    Image {
        id: apple_2
        source: "images/apple-h2.png"
        smooth: true
        visible: false
        anchors.bottom: apple.bottom
        anchors.left:apple.left
        anchors.leftMargin: Math.floor(Math.random()*50+30)

        NumberAnimation on rotation { id: ry; from: 360; to: 0; duration: Math.floor(Math.random()*3000+600); loops: Animation.Infinite }
    }

    //main fruit
    Image {
        id: apple
        source: "images/apple.png"
        smooth: true

        NumberAnimation on rotation { id: ri; from: 0; to: 360; duration: Math.floor(Math.random()*1000+2700); loops: Animation.Infinite }

        //y-axis animation
        property int maxHeight: 230
        property int minHeight: -Math.floor(Math.random()*100+345)

        y: minHeight

        SequentialAnimation on y {
            id: ay
            loops: Animation.Infinite
            running: true

            NumberAnimation {
                from: apple.maxHeight; to: apple.minHeight
                easing.type: Easing.OutCubic; duration: 1300
            }

            NumberAnimation {
                from: apple.minHeight; to: apple.maxHeight
                easing.type: Easing.InCubic; duration: 1300
            }

            PauseAnimation { duration: 3000 }

        }

        //x-axis animation
        property int maxWidth: Math.floor(Math.random()*200-60)
        property int minWidth: Math.floor(Math.random()*200-60)

        x: minWidth

        SequentialAnimation on x {
            id: ax
            running: true
            loops: Animation.Infinite

            NumberAnimation {
                from: apple.maxWidth; to: apple.minWidth
                easing.type: Easing.OutCubic; duration: 1300
            }

            NumberAnimation {
                from: apple.minWidth; to: apple.minWidth*2-apple.maxWidth
                easing.type: Easing.InCubic; duration: 1300
            }

            PauseAnimation { duration: 3000 }

        }

    }

    Timer {
        id: theTimer
        interval: 1
        repeat: true
        running: true
        onTriggered: {
            rootscr.aY = apple.y;
            rootscr.aW = apple.width;
            rootscr.aH = apple.height;
            if(rootscr.appleC == 1  && rootscr.gResume == 1 && rootscr.fox == 7){
                rootscr.appleC = 0;
                apple.opacity = 0;
                apple_1.visible = true;
                apple_2.visible = true;
                rootscr.score = rootscr.score + 1;
                rootscr.aHit = 1;
                rootscr.foxone = 7;
            }
        }
    }

    property int deep: 0

       Timer {
        id: frameTimer
        interval: 1
        repeat: true
        running: true

        onTriggered: {

            if(rootscr.fox == 6){
                ay.stop();
                ax.stop();
                ry.stop();
                rx.stop();
                ri.stop();
                if(rootscr.fox == 6){
                    apple.y = apple.maxHeight;
                    apple_splash.opacity = 0;
                }
            } else if(rootscr.fox == 7){
                ay.start();
                ax.start();
                ry.start();
                rx.start();
                ri.start();
                apple_splash.opacity = 1;

                //for restart
                if(rootscr.reST == 1){

                    ay.restart();
                    ax.restart();
                    ry.restart();
                    rx.restart();
                    ri.restart();
                    rootscr.reST = 0;
                    //rootscr.score = 0;
                    rootscr.life = 12;
                    if(rootapple.deep == 1){
                        rootscr.life = rootscr.life + 1;
                        rootapple.deep = 0;
                    }
                }

                //control for x-axis, it will work with rootscr
                if(apple.y == apple.maxHeight){
                    rootscr.aG = 1;
                } else {
                    rootscr.aG = 0;
                }

                if(rootscr.conN == 1 && rootscr.gResume == 0){
                    ay.pause();
                    ax.pause();
                    ry.pause();
                    rx.pause();
                    ri.pause();
                } else if(rootscr.gResume == 1 && rootscr.conN == 0) {
                    ay.resume();
                    ax.resume();
                    ry.resume();
                    rx.resume();
                    ri.resume();
                    rootscr.visR = 0;

                    if(apple.y < -20 && apple.opacity == 1){
                        rootapple.deep = 1;
                    } else if(apple.y < -20 && apple.opacity == 0){
                        rootapple.deep = 0;
                    }

                    if(apple.y > -10 && apple.opacity == 0){
                        apple.opacity = 1;
                        apple_1.visible = false;
                        apple_2.visible = false;
                        rootscr.aHit = 0;
                        rootscr.appleS = 0;
                    } else if(apple.y > -10 && apple.opacity == 1 && rootapple.deep == 1){
                        rootapple.deep = 0;
                        rootscr.life = rootscr.life - 1;
                    }
                }
            }
        }
    }
}
