import QtQuick 1.1
import com.nokia.meego 1.0

Item {
    id: rootbanana

    //cut the fruit - part[1]
    Image {
        id: banana_1
        source: "images/banana-h1.png"
        smooth: true
        visible: false
        anchors.bottom: banana.bottom
        anchors.right:banana.right
        anchors.rightMargin: Math.floor(Math.random()*30+30)

        NumberAnimation on rotation { id: rx; from: 0; to: 360; duration: Math.floor(Math.random()*3000+600); loops: Animation.Infinite }
    }

    //cut the fruit - part[2]
    Image {
        id: banana_2
        source: "images/banana-h2.png"
        smooth: true
        visible: false
        anchors.bottom: banana.bottom
        anchors.left:banana.left
        anchors.leftMargin: Math.floor(Math.random()*50+30)

        NumberAnimation on rotation { id: ry; from: 360; to: 0; duration: Math.floor(Math.random()*3000+600); loops: Animation.Infinite }
    }

    //main fruit
    Image {
        id: banana
        source: "images/banana.png"
        smooth: true

        NumberAnimation on rotation { id: ri; from: 0; to: 360; duration: Math.floor(Math.random()*1000+2700); loops: Animation.Infinite }

        //y-axis animation
        property int maxHeight: 230
        property int minHeight: -Math.floor(Math.random()*100+345)

        y: minHeight

        SequentialAnimation on y {
            id: ay
            loops: Animation.Infinite
            running: true

            NumberAnimation {
                from: banana.maxHeight; to: banana.minHeight
                easing.type: Easing.OutCubic; duration: 1300
            }

            NumberAnimation {
                from: banana.minHeight; to: banana.maxHeight
                easing.type: Easing.InCubic; duration: 1300
            }

            PauseAnimation { duration: 2300 }

        }

        //x-axis animation
        property int maxWidth: Math.floor(Math.random()*200-60)
        property int minWidth: Math.floor(Math.random()*200-60)

        x: minWidth

        SequentialAnimation on x {
            id: ax
            running: true
            loops: Animation.Infinite

            NumberAnimation {
                from: banana.maxWidth; to: banana.minWidth
                easing.type: Easing.OutCubic; duration: 1300
            }

            NumberAnimation {
                from: banana.minWidth; to: banana.minWidth*2-banana.maxWidth
                easing.type: Easing.InCubic; duration: 1300
            }

            PauseAnimation { duration: 2300 }

        }

    }

    Timer {
        id: theTimer
        interval: 1
        repeat: true
        running: true
        onTriggered: {
            rootscr.bY = banana.y;
            rootscr.bW = banana.width;
            rootscr.bH = banana.height;
            if(rootscr.bananaC == 1  && rootscr.gResume == 1 && rootscr.foxone == 7){
                rootscr.bananaC = 0;
                banana.opacity = 0;
                banana_1.visible = true;
                banana_2.visible = true;
                rootscr.score = rootscr.score + 1;
                rootscr.bHit = 1;
                rootscr.foxtwo = 7;
            }
        }
    }

    property int deep: 0

       Timer {
        id: frameTimer
        interval: 1
        repeat: true
        running: true

        onTriggered: {

            if(rootscr.foxone == 6){
                ay.stop();
                ax.stop();
                ry.stop();
                rx.stop();
                ri.stop();
                //banana.visible = false;
                if(rootscr.foxone == 6){
                    banana.y = banana.maxHeight;
                    banana_splash.opacity = 0;
                }
            } else if(rootscr.foxone == 7){
                ay.start();
                ax.start();
                ry.start();
                rx.start();
                ri.start();
                banana_splash.opacity = 1;

                //for restart
                if(rootscr.reSTbanana == 1){

                    ay.restart();
                    ax.restart();
                    ry.restart();
                    rx.restart();
                    ri.restart();
                    rootscr.reSTbanana = 0;
                    //rootscr.score = 0;
                    rootscr.life = 12;
                    if(rootbanana.deep == 1){
                        rootscr.life = rootscr.life + 1;
                        rootbanana.deep = 0;
                    }
                }

                //control for x-axis, it will work with rootscr
                if(banana.y == banana.maxHeight){
                    rootscr.bG = 1;
                } else {
                    rootscr.bG = 0;
                }

                if(rootscr.conN == 1 && rootscr.gResume == 0){
                    ay.pause();
                    ax.pause();
                    ry.pause();
                    rx.pause();
                    ri.pause();
                } else if(rootscr.gResume == 1 && rootscr.conN == 0) {
                    ay.resume();
                    ax.resume();
                    ry.resume();
                    rx.resume();
                    ri.resume();
                    rootscr.visR = 0;

                    if(banana.y < -20 && banana.opacity == 1){
                        rootbanana.deep = 1;
                    } else if(banana.y < -20 && banana.opacity == 0){
                        rootbanana.deep = 0;
                    }

                    if(banana.y > -10 && banana.opacity == 0){
                        banana.opacity = 1;
                        banana_1.visible = false;
                        banana_2.visible = false;
                        rootscr.bHit = 0;
                        rootscr.bananaS = 0;
                    } else if(banana.y > -10 && banana.opacity == 1 && rootbanana.deep == 1){
                        rootbanana.deep = 0;
                        rootscr.life = rootscr.life - 1;
                    }
                }
            }
        }
    }
}
