import QtQuick 1.1
import com.nokia.meego 1.0

Item {
    id: rootberry

    //Hover-Red
    Image {
        id: hoverRed
        opacity: 0.4
        source: "images/red.png"
        anchors.horizontalCenter: berry.horizontalCenter
        anchors.verticalCenter: berry.verticalCenter

        NumberAnimation on rotation { id: hx; from: 0; to: 360; duration: 3000; loops: Animation.Infinite }
    }

    //cut the fruit - part[1]
    Image {
        id: berry_1
        source: "images/berry-h1.png"
        smooth: true
        visible: false
        anchors.bottom: berry.bottom
        anchors.right:berry.right
        anchors.rightMargin: Math.floor(Math.random()*30+30)

        NumberAnimation on rotation { id: rx; from: 0; to: 360; duration: Math.floor(Math.random()*3000+600); loops: Animation.Infinite }
    }

    //cut the fruit - part[2]
    Image {
        id: berry_2
        source: "images/berry-h2.png"
        smooth: true
        visible: false
        anchors.bottom: berry.bottom
        anchors.left:berry.left
        anchors.leftMargin: Math.floor(Math.random()*50+30)

        NumberAnimation on rotation { id: ry; from: 360; to: 0; duration: Math.floor(Math.random()*3000+600); loops: Animation.Infinite }
    }

    //main fruit
    Image {
        id: berry
        source: "images/berry.png"
        smooth: true

        NumberAnimation on rotation { id: ri; from: 0; to: 360; duration: Math.floor(Math.random()*1000+2700); loops: Animation.Infinite }

        //y-axis animation
        property int maxHeight: 230
        property int minHeight: -Math.floor(Math.random()*100+345)

        y: minHeight

        SequentialAnimation on y {
            id: ay
            loops: Animation.Infinite
            running: true

            NumberAnimation {
                from: berry.maxHeight; to: berry.minHeight
                easing.type: Easing.OutCubic; duration: 2000
            }

            NumberAnimation {
                from: berry.minHeight; to: berry.maxHeight
                easing.type: Easing.InCubic; duration: 2000
            }

            PauseAnimation { duration: 30000 }

        }

        //x-axis animation
        property int maxWidth: Math.floor(Math.random()*200-60)
        property int minWidth: Math.floor(Math.random()*200-60)

        x: minWidth

        SequentialAnimation on x {
            id: ax
            running: true
            loops: Animation.Infinite

            NumberAnimation {
                from: berry.maxWidth; to: berry.minWidth
                easing.type: Easing.OutCubic; duration: 2000
            }

            NumberAnimation {
                from: berry.minWidth; to: berry.minWidth*2-berry.maxWidth
                easing.type: Easing.InCubic; duration: 2000
            }

            PauseAnimation { duration: 30000 }

        }

    }

    Timer {
        id: theTimer
        interval: 1
        repeat: true
        running: true
        onTriggered: {
            rootscr.sY = berry.y;
            rootscr.sW = berry.width;
            rootscr.sH = berry.height;
            if(rootscr.berryC == 1  && rootscr.gResume == 1 && rootscr.foxone == 7){
                rootscr.berryC = 0;
                berry.opacity = 0;
                hoverRed.opacity = 0;
                berry_1.visible = true;
                berry_2.visible = true;
                rootscr.score = rootscr.score + 20;
                rootscr.sHit = 1;
            }
        }
    }

    property int deep: 0

       Timer {
        id: frameTimer
        interval: 1
        repeat: true
        running: true

        onTriggered: {

            if(rootscr.foxberry == 6){
                ay.stop();
                ax.stop();
                ry.stop();
                rx.stop();
                ri.stop();
                hx.stop();
                if(rootscr.foxberry == 6){
                    berry.y = berry.maxHeight;
                    berry_splash.opacity = 0;
                }
            } else if(rootscr.foxberry == 7){
                ay.start();
                ax.start();
                ry.start();
                rx.start();
                ri.start();
                hx.start();
                berry_splash.opacity = 1;

                if(rootscr.life)

                //for restart
                if(rootscr.reSTberry == 1){
                    ay.restart();
                    ax.restart();
                    ry.restart();
                    rx.restart();
                    ri.restart();
                    hx.restart();
                    rootscr.reSTberry = 0;
                    //rootscr.score = 0;
                    rootscr.life = 12;
                    if(rootberry.deep == 1){
                        rootscr.life = rootscr.life + 1;
                        rootberry.deep = 0;
                    }
                }

                //control for x-axis, it will work with rootscr
                if(berry.y == berry.maxHeight){
                    rootscr.sG = 1;
                } else {
                    rootscr.sG = 0;
                }

                if(rootscr.conN == 1 && rootscr.gResume == 0){
                    ay.pause();
                    ax.pause();
                    ry.pause();
                    rx.pause();
                    ri.pause();
                    hx.pause();
                } else if(rootscr.gResume == 1 && rootscr.conN == 0) {
                    ay.resume();
                    ax.resume();
                    ry.resume();
                    rx.resume();
                    ri.resume();
                    hx.resume();
                    rootscr.visR = 0;

                    if(berry.y < -20 && berry.opacity == 1){
                        rootberry.deep = 1;
                    } else if(berry.y < -20 && berry.opacity == 0){
                        rootberry.deep = 0;
                    }

                    if(berry.y > -10 && berry.opacity == 0){
                        berry.opacity = 1;
                        hoverRed.opacity = 0.4;
                        berry_1.visible = false;
                        berry_2.visible = false;
                        rootscr.sHit = 0;
                        rootscr.berryS = 0;
                    } else if(berry.y > -10 && berry.opacity == 1 && rootberry.deep == 1){
                        rootberry.deep = 0;
                        rootscr.life = rootscr.life - 1;
                    }
                }
            }
        }
    }
}
