import QtQuick 1.1
import com.nokia.meego 1.0

Item {
    id: rootbomb

    //cut the fruit - part[1]
        Image {
            id: bomb_1
            source: "images/bomb-h1.png"
            smooth: true
            visible: false
            anchors.bottom: bomb.bottom
            anchors.right:bomb.right
            anchors.rightMargin: Math.floor(Math.random()*30+30)

            NumberAnimation on rotation { id: rx; from: 0; to: 360; duration: Math.floor(Math.random()*3000+600); loops: Animation.Infinite }
        }

        //cut the fruit - part[2]
        Image {
            id: bomb_2
            source: "images/bomb-h2.png"
            smooth: true
            visible: false
            anchors.bottom: bomb.bottom
            anchors.left:bomb.left
            anchors.leftMargin: Math.floor(Math.random()*50+30)

            NumberAnimation on rotation { id: ry; from: 360; to: 0; duration: Math.floor(Math.random()*3000+600); loops: Animation.Infinite }
        }

    //main fruit
    Image {
        id: bomb
        source: "images/bomb.png"
        smooth: true

        NumberAnimation on rotation { id: ri; from: 0; to: 360; duration: Math.floor(Math.random()*1000+2700); loops: Animation.Infinite }

        //y-axis animation
        property int maxHeight: 250
        property int minHeight: -Math.floor(Math.random()*100+345)

        y: minHeight

        SequentialAnimation on y {
            id: ay
            loops: Animation.Infinite
            running: true

            NumberAnimation {
                from: bomb.maxHeight; to: bomb.minHeight
                easing.type: Easing.OutCubic; duration: 900
            }

            NumberAnimation {
                from: bomb.minHeight; to: bomb.maxHeight
                easing.type: Easing.InCubic; duration: 900
            }

            PauseAnimation { duration: 8370 }

        }

        //x-axis animation
        property int maxWidth: Math.floor(Math.random()*200-60)
        property int minWidth: Math.floor(Math.random()*200-60)

        x: minWidth

        SequentialAnimation on x {
            id: ax
            running: true
            loops: Animation.Infinite

            NumberAnimation {
                from: bomb.maxWidth; to: bomb.minWidth
                easing.type: Easing.OutCubic; duration: 900
            }

            NumberAnimation {
                from: bomb.minWidth; to: bomb.minWidth*2-bomb.maxWidth
                easing.type: Easing.InCubic; duration: 900
            }

            PauseAnimation { duration: 8370 }

        }

    }

    Timer {
        id: theTimer
        interval: 1
        repeat: true
        running: true
        onTriggered: {
            rootscr.bbY = bomb.y;
            rootscr.bbW = bomb.width;
            rootscr.aH = bomb.height;
            if(rootscr.bombC == 1  && rootscr.gResume == 1 && rootscr.foxone == 7){
                rootscr.bombC = 0;
                bomb.opacity = 0;
                bomb_1.visible = true;
                bomb_2.visible = true;
                rootscr.bbHit = 1;
                if(bomb.y < -30){
                    rootscr.life = rootscr.life - 2;
                    rootscr.bombC = 0;
                }
            }
        }
    }

    property int deep: 0

       Timer {
        id: frameTimer
        interval: 1
        repeat: true
        running: true

        onTriggered: {

            if(rootscr.foxthree == 6){
                ay.stop();
                ax.stop();
                ry.stop();
                rx.stop();
                ri.stop();
                if(rootscr.foxthree == 6){
                    bomb.y = bomb.maxHeight;
                    bomb_splash.opacity = 0;
                }
            } else if(rootscr.foxone == 7){
                ay.start();
                ax.start();
                ry.start();
                rx.start();
                ri.start();
                bomb_splash.opacity = 1;


                //for restart
                if(rootscr.reSTbomb == 1){
                    rootscr.foxthree = 6;
                    ay.restart();
                    ax.restart();
                    ry.restart();
                    rx.restart();
                    ri.restart();
                    rootscr.reSTbomb = 0;
                    //rootscr.score = 0;
                    rootscr.life = 12;
                }

                //control for x-axis, it will work with rootscr
                if(bomb.y == bomb.maxHeight){
                    rootscr.bbG = 1;
                } else {
                    rootscr.bbG = 0;
                }

                if(rootscr.conN == 1 && rootscr.gResume == 0){
                    ay.pause();
                    ax.pause();
                    ry.pause();
                    rx.pause();
                    ri.pause();
                } else if(rootscr.gResume == 1 && rootscr.conN == 0) {
                    ay.resume();
                    ax.resume();
                    ry.resume();
                    rx.resume();
                    ri.resume();
                    rootscr.visR = 0;

                    if(bomb.y < -20 && bomb.opacity == 1){
                        rootbomb.deep = 1;
                    } else if(bomb.y < -20 && bomb.opacity == 0){
                        rootbomb.deep = 0;
                    }

                    if(bomb.y > -10 && bomb.opacity == 0){
                        bomb.opacity = 1;
                        bomb_1.visible = false;
                        bomb_2.visible = false;
                        rootscr.bbHit = 0;
                        rootscr.bombS = 0;
                    }
                }
            }
        }
    }
}
