import QtQuick 1.1
import com.nokia.meego 1.0

Item {
    id: rootgranade

    //cut the fruit - part[1]
        Image {
            id: granade_1
            source: "images/granade-h1.png"
            smooth: true
            visible: false
            anchors.bottom: granade.bottom
            anchors.right:granade.right
            anchors.rightMargin: Math.floor(Math.random()*30+30)

            NumberAnimation on rotation { id: rx; from: 0; to: 360; duration: Math.floor(Math.random()*3000+600); loops: Animation.Infinite }
        }

        //cut the fruit - part[2]
        Image {
            id: granade_2
            source: "images/granade-h2.png"
            smooth: true
            visible: false
            anchors.bottom: granade.bottom
            anchors.left:granade.left
            anchors.leftMargin: Math.floor(Math.random()*50+30)

            NumberAnimation on rotation { id: ry; from: 360; to: 0; duration: Math.floor(Math.random()*3000+600); loops: Animation.Infinite }
        }

    //main fruit
    Image {
        id: granade
        source: "images/granade.png"
        smooth: true

        NumberAnimation on rotation { id: ri; from: 0; to: 360; duration: Math.floor(Math.random()*1000+2700); loops: Animation.Infinite }

        //y-axis animation
        property int maxHeight: 250
        property int minHeight: -Math.floor(Math.random()*100+345)

        y: minHeight

        SequentialAnimation on y {
            id: ay
            loops: Animation.Infinite
            running: true

            NumberAnimation {
                from: granade.maxHeight; to: granade.minHeight
                easing.type: Easing.OutCubic; duration: 900
            }

            NumberAnimation {
                from: granade.minHeight; to: granade.maxHeight
                easing.type: Easing.InCubic; duration: 900
            }

            PauseAnimation { duration: 10000 }

        }

        //x-axis animation
        property int maxWidth: Math.floor(Math.random()*200-60)
        property int minWidth: Math.floor(Math.random()*200-60)

        x: minWidth

        SequentialAnimation on x {
            id: ax
            running: true
            loops: Animation.Infinite

            NumberAnimation {
                from: granade.maxWidth; to: granade.minWidth
                easing.type: Easing.OutCubic; duration: 900
            }

            NumberAnimation {
                from: granade.minWidth; to: granade.minWidth*2-granade.maxWidth
                easing.type: Easing.InCubic; duration: 900
            }

            PauseAnimation { duration: 10000 }

        }

    }

    Timer {
        id: theTimer
        interval: 1
        repeat: true
        running: true
        onTriggered: {
            rootscr.gY = granade.y;
            rootscr.gW = granade.width;
            rootscr.aH = granade.height;
            if(rootscr.granadeC == 1  && rootscr.gResume == 1 && rootscr.foxone == 7){
                rootscr.granadeC = 0;
                granade.opacity = 0;
                granade_1.visible = true;
                granade_2.visible = true;
                rootscr.gHit = 1;
                if(granade.y < -30){
                    rootscr.life = rootscr.life - 2;
                    rootscr.granadeC = 0;
                }
            }
        }
    }

    property int deep: 0

       Timer {
        id: frameTimer
        interval: 1
        repeat: true
        running: true

        onTriggered: {

            if(rootscr.foxgranade == 6){
                ay.stop();
                ax.stop();
                ry.stop();
                rx.stop();
                ri.stop();
                if(rootscr.foxgranade == 6){
                    granade.y = granade.maxHeight;
                    granade_splash.opacity = 0;
                }
            } else if(rootscr.foxgranade == 7){
                ay.start();
                ax.start();
                ry.start();
                rx.start();
                ri.start();
                granade_splash.opacity = 1;


                //for restart
                if(rootscr.reSTgranade == 1){
                    ay.restart();
                    ax.restart();
                    ry.restart();
                    rx.restart();
                    ri.restart();
                    rootscr.reSTgranade = 0;
                    //rootscr.score = 0;
                    rootscr.life = 12;
                }

                //control for x-axis, it will work with rootscr
                if(granade.y == granade.maxHeight){
                    rootscr.gG = 1;
                } else {
                    rootscr.gG = 0;
                }

                if(rootscr.conN == 1 && rootscr.gResume == 0){
                    ay.pause();
                    ax.pause();
                    ry.pause();
                    rx.pause();
                    ri.pause();
                } else if(rootscr.gResume == 1 && rootscr.conN == 0) {
                    ay.resume();
                    ax.resume();
                    ry.resume();
                    rx.resume();
                    ri.resume();
                    rootscr.visR = 0;

                    if(granade.y < -20 && granade.opacity == 1){
                        rootgranade.deep = 1;
                    } else if(granade.y < -20 && granade.opacity == 0){
                        rootgranade.deep = 0;
                    }

                    if(granade.y > -10 && granade.opacity == 0){
                        granade.opacity = 1;
                        granade_1.visible = false;
                        granade_2.visible = false;
                        rootscr.gHit = 0;
                        rootscr.granadeS = 0;
                    }
                }
            }
        }
    }
}
