import QtQuick 1.1
import com.nokia.meego 1.0

Item {
    id: rootkiwi

    //cut the fruit - part[1]
    Image {
        id: kiwi_1
        source: "images/kiwi-h1.png"
        smooth: true
        visible: false
        anchors.bottom: kiwi.bottom
        anchors.right:kiwi.right
        anchors.rightMargin: Math.floor(Math.random()*30+30)

        NumberAnimation on rotation { id: rx; from: 0; to: 360; duration: Math.floor(Math.random()*3000+600); loops: Animation.Infinite }
    }

    //cut the fruit - part[2]
    Image {
        id: kiwi_2
        source: "images/kiwi-h2.png"
        smooth: true
        visible: false
        anchors.bottom: kiwi.bottom
        anchors.left:kiwi.left
        anchors.leftMargin: Math.floor(Math.random()*50+30)

        NumberAnimation on rotation { id: ry; from: 360; to: 0; duration: Math.floor(Math.random()*3000+600); loops: Animation.Infinite }
    }

    //main fruit
    Image {
        id: kiwi
        source: "images/kiwi.png"
        smooth: true

        NumberAnimation on rotation { id: ri; from: 0; to: 360; duration: Math.floor(Math.random()*1000+2700); loops: Animation.Infinite }

        //y-axis animation
        property int maxHeight: 230
        property int minHeight: -Math.floor(Math.random()*100+345)

        y: minHeight

        SequentialAnimation on y {
            id: ay
            loops: Animation.Infinite
            running: true

            NumberAnimation {
                from: kiwi.maxHeight; to: kiwi.minHeight
                easing.type: Easing.OutCubic; duration: 1300
            }

            NumberAnimation {
                from: kiwi.minHeight; to: kiwi.maxHeight
                easing.type: Easing.InCubic; duration: 1300
            }

            PauseAnimation { duration: 6000 }

        }

        //x-axis animation
        property int maxWidth: Math.floor(Math.random()*200-60)
        property int minWidth: Math.floor(Math.random()*200-60)

        x: minWidth

        SequentialAnimation on x {
            id: ax
            running: true
            loops: Animation.Infinite

            NumberAnimation {
                from: kiwi.maxWidth; to: kiwi.minWidth
                easing.type: Easing.OutCubic; duration: 1300
            }

            NumberAnimation {
                from: kiwi.minWidth; to: kiwi.minWidth*2-kiwi.maxWidth
                easing.type: Easing.InCubic; duration: 1300
            }

            PauseAnimation { duration: 6000 }

        }

    }

    Timer {
        id: theTimer
        interval: 1
        repeat: true
        running: true
        onTriggered: {
            rootscr.kY = kiwi.y;
            rootscr.kW = kiwi.width;
            rootscr.kH = kiwi.height;
            if(rootscr.kiwiC == 1  && rootscr.gResume == 1 && rootscr.foxtwo == 7){
                rootscr.kiwiC = 0;
                kiwi.opacity = 0;
                kiwi_1.visible = true;
                kiwi_2.visible = true;
                rootscr.score = rootscr.score + 1;
                rootscr.kHit = 1;
                rootscr.foxthree = 7;
            }
        }
    }

    property int deep: 0

       Timer {
        id: frameTimer
        interval: 1
        repeat: true
        running: true

        onTriggered: {

            if(rootscr.foxtwo == 6){
                ay.stop();
                ax.stop();
                ry.stop();
                rx.stop();
                ri.stop();
                if(rootscr.foxtwo == 6){
                    kiwi.y = kiwi.maxHeight;
                    kiwi_splash.opacity = 0;
                }
            } else if(rootscr.foxtwo == 7){
                ay.start();
                ax.start();
                ry.start();
                rx.start();
                ri.start();
                kiwi_splash.opacity = 1;


                //for restart
                if(rootscr.reSTkiwi == 1){
                    rootscr.foxtwo = 6;
                    ay.restart();
                    ax.restart();
                    ry.restart();
                    rx.restart();
                    ri.restart();
                    rootscr.reSTkiwi = 0;
                    //rootscr.score = 0;
                    rootscr.life = 12;
                    if(rootkiwi.deep == 1){
                        rootscr.life = rootscr.life + 1;
                        rootkiwi.deep = 0;
                    }
                }

                //control for x-axis, it will work with rootscr
                if(kiwi.y == kiwi.maxHeight){
                    rootscr.kG = 1;
                } else {
                    rootscr.kG = 0;
                }

                if(rootscr.conN == 1 && rootscr.gResume == 0){
                    ay.pause();
                    ax.pause();
                    ry.pause();
                    rx.pause();
                    ri.pause();
                } else if(rootscr.gResume == 1 && rootscr.conN == 0) {
                    ay.resume();
                    ax.resume();
                    ry.resume();
                    rx.resume();
                    ri.resume();
                    rootscr.visR = 0;

                    if(kiwi.y < -20 && kiwi.opacity == 1){
                        rootkiwi.deep = 1;
                    } else if(kiwi.y < -20 && kiwi.opacity == 0){
                        rootkiwi.deep = 0;
                    }

                    if(kiwi.y > -10 && kiwi.opacity == 0){
                        kiwi.opacity = 1;
                        kiwi_1.visible = false;
                        kiwi_2.visible = false;
                        rootscr.kHit = 0;
                        rootscr.kiwiS = 0;
                    } else if(kiwi.y > -10 && kiwi.opacity == 1 && rootkiwi.deep == 1){
                        rootkiwi.deep = 0;
                        rootscr.life = rootscr.life - 1;
                    }
                }
            }
        }
    }
}
