import QtQuick 1.1
import com.nokia.meego 1.0

Item {
    id: rootlemon

    //cut the fruit - part[1]
    Image {
        id: lemon_1
        source: "images/lemon-h1.png"
        smooth: true
        visible: false
        anchors.bottom: lemon.bottom
        anchors.right:lemon.right
        anchors.rightMargin: Math.floor(Math.random()*30+30)

        NumberAnimation on rotation { id: rx; from: 0; to: 360; duration: Math.floor(Math.random()*3000+600); loops: Animation.Infinite }
    }

    //cut the fruit - part[2]
    Image {
        id: lemon_2
        source: "images/lemon-h2.png"
        smooth: true
        visible: false
        anchors.bottom: lemon.bottom
        anchors.left:lemon.left
        anchors.leftMargin: Math.floor(Math.random()*50+30)

        NumberAnimation on rotation { id: ry; from: 360; to: 0; duration: Math.floor(Math.random()*3000+600); loops: Animation.Infinite }
    }

    //main fruit
    Image {
        id: lemon
        source: "images/lemon.png"
        smooth: true

        NumberAnimation on rotation { id: ri; from: 0; to: 360; duration: Math.floor(Math.random()*1000+2700); loops: Animation.Infinite }

        //y-axis animation
        property int maxHeight: 230
        property int minHeight: -Math.floor(Math.random()*100+345)

        y: minHeight

        SequentialAnimation on y {
            id: ay
            loops: Animation.Infinite
            running: true

            NumberAnimation {
                from: lemon.maxHeight; to: lemon.minHeight
                easing.type: Easing.OutCubic; duration: 1300
            }

            NumberAnimation {
                from: lemon.minHeight; to: lemon.maxHeight
                easing.type: Easing.InCubic; duration: 1300
            }

            PauseAnimation { duration: 3200 }

        }

        //x-axis animation
        property int maxWidth: Math.floor(Math.random()*200-60)
        property int minWidth: Math.floor(Math.random()*200-60)

        x: minWidth

        SequentialAnimation on x {
            id: ax
            running: true
            loops: Animation.Infinite

            NumberAnimation {
                from: lemon.maxWidth; to: lemon.minWidth
                easing.type: Easing.OutCubic; duration: 1300
            }

            NumberAnimation {
                from: lemon.minWidth; to: lemon.minWidth*2-lemon.maxWidth
                easing.type: Easing.InCubic; duration: 1300
            }

            PauseAnimation { duration: 3200 }

        }

    }

    Timer {
        id: theTimer
        interval: 1
        repeat: true
        running: true
        onTriggered: {
            rootscr.lY = lemon.y;
            rootscr.lW = lemon.width;
            rootscr.lH = lemon.height;
            if(rootscr.lemonC == 1  && rootscr.gResume == 1 && rootscr.foxthree == 7){
                rootscr.lemonC = 0;
                lemon.opacity = 0;
                lemon_1.visible = true;
                lemon_2.visible = true;
                rootscr.score = rootscr.score + 1;
                rootscr.lHit = 1;
                rootscr.foxfour = 7;
            }
        }
    }

    property int deep: 0

       Timer {
        id: frameTimer
        interval: 1
        repeat: true
        running: true

        onTriggered: {

            if(rootscr.foxthree == 6){
                ay.stop();
                ax.stop();
                ry.stop();
                rx.stop();
                ri.stop();
                if(rootscr.foxthree == 6){
                    lemon.y = lemon.maxHeight;
                    lemon_splash.opacity = 0;
                }
            } else if(rootscr.foxthree == 7){
                ay.start();
                ax.start();
                ry.start();
                rx.start();
                ri.start();
                lemon_splash.opacity = 1;


                //for restart
                if(rootscr.reSTlemon == 1){

                    ay.restart();
                    ax.restart();
                    ry.restart();
                    rx.restart();
                    ri.restart();
                    rootscr.reSTlemon = 0;
                    //rootscr.score = 0;
                    rootscr.life = 12;
                    if(rootlemon.deep == 1){
                        rootscr.life = rootscr.life + 1;
                        rootlemon.deep = 0;
                    }
                }

                //control for x-axis, it will work with rootscr
                if(lemon.y == lemon.maxHeight){
                    rootscr.lG = 1;
                } else {
                    rootscr.lG = 0;
                }

                if(rootscr.conN == 1 && rootscr.gResume == 0){
                    ay.pause();
                    ax.pause();
                    ry.pause();
                    rx.pause();
                    ri.pause();
                } else if(rootscr.gResume == 1 && rootscr.conN == 0) {
                    ay.resume();
                    ax.resume();
                    ry.resume();
                    rx.resume();
                    ri.resume();
                    rootscr.visR = 0;

                    if(lemon.y < -20 && lemon.opacity == 1){
                        rootlemon.deep = 1;
                    } else if(lemon.y < -20 && lemon.opacity == 0){
                        rootlemon.deep = 0;
                    }

                    if(lemon.y > -10 && lemon.opacity == 0){
                        lemon.opacity = 1;
                        lemon_1.visible = false;
                        lemon_2.visible = false;
                        rootscr.lHit = 0;
                        rootscr.lemonS = 0;
                    } else if(lemon.y > -10 && lemon.opacity == 1 && rootlemon.deep == 1){
                        rootlemon.deep = 0;
                        rootscr.life = rootscr.life - 1;
                    }
                }
            }
        }
    }
}
