import QtQuick 1.1
import com.nokia.meego 1.0

Item {
    id: rootmango

    //cut the fruit - part[1]
    Image {
        id: mango_1
        source: "images/mango-h1.png"
        smooth: true
        visible: false
        anchors.bottom: mango.bottom
        anchors.right:mango.right
        anchors.rightMargin: Math.floor(Math.random()*30+30)

        NumberAnimation on rotation { id: rx; from: 0; to: 360; duration: Math.floor(Math.random()*3000+600); loops: Animation.Infinite }
    }

    //cut the fruit - part[2]
    Image {
        id: mango_2
        source: "images/mango-h2.png"
        smooth: true
        visible: false
        anchors.bottom: mango.bottom
        anchors.left:mango.left
        anchors.leftMargin: Math.floor(Math.random()*50+30)

        NumberAnimation on rotation { id: ry; from: 360; to: 0; duration: Math.floor(Math.random()*3000+600); loops: Animation.Infinite }
    }

    //main fruit
    Image {
        id: mango
        source: "images/mango.png"
        smooth: true

        NumberAnimation on rotation { id: ri; from: 0; to: 360; duration: Math.floor(Math.random()*1000+2700); loops: Animation.Infinite }

        //y-axis animation
        property int maxHeight: 230
        property int minHeight: -Math.floor(Math.random()*100+345)

        y: minHeight

        SequentialAnimation on y {
            id: ay
            loops: Animation.Infinite
            running: true

            NumberAnimation {
                from: mango.maxHeight; to: mango.minHeight
                easing.type: Easing.OutCubic; duration: 1300
            }

            NumberAnimation {
                from: mango.minHeight; to: mango.maxHeight
                easing.type: Easing.InCubic; duration: 1300
            }

            PauseAnimation { duration: 5000 }

        }

        //x-axis animation
        property int maxWidth: Math.floor(Math.random()*200-60)
        property int minWidth: Math.floor(Math.random()*200-60)

        x: minWidth

        SequentialAnimation on x {
            id: ax
            running: true
            loops: Animation.Infinite

            NumberAnimation {
                from: mango.maxWidth; to: mango.minWidth
                easing.type: Easing.OutCubic; duration: 1300
            }

            NumberAnimation {
                from: mango.minWidth; to: mango.minWidth*2-mango.maxWidth
                easing.type: Easing.InCubic; duration: 1300
            }

            PauseAnimation { duration: 5000 }

        }

    }

    Timer {
        id: theTimer
        interval: 1
        repeat: true
        running: true
        onTriggered: {
            rootscr.mY = mango.y;
            rootscr.mW = mango.width;
            rootscr.mH = mango.height;
            if(rootscr.mangoC == 1  && rootscr.gResume == 1 && rootscr.foxfour == 7){
                rootscr.mangoC = 0;
                mango.opacity = 0;
                mango_1.visible = true;
                mango_2.visible = true;
                rootscr.score = rootscr.score + 1;
                rootscr.mHit = 1;
                rootscr.foxfive = 7;
            }
        }
    }

    property int deep: 0

       Timer {
        id: frameTimer
        interval: 1
        repeat: true
        running: true

        onTriggered: {

            if(rootscr.foxfour == 6){
                ay.stop();
                ax.stop();
                ry.stop();
                rx.stop();
                ri.stop();
                if(rootscr.foxfour == 6){
                    mango.y = mango.maxHeight;
                    mango_splash.opacity = 0;
                }
            } else if(rootscr.foxfour == 7){
                ay.start();
                ax.start();
                ry.start();
                rx.start();
                ri.start();
                mango_splash.opacity = 1;


                //for restart
                if(rootscr.reSTmango == 1){
                    rootscr.foxfour = 6;
                    ay.restart();
                    ax.restart();
                    ry.restart();
                    rx.restart();
                    ri.restart();
                    rootscr.reSTmango = 0;
                    //rootscr.score = 0;
                    rootscr.life = 12;
                    if(rootmango.deep == 1){
                        rootscr.life = rootscr.life + 1;
                        rootmango.deep = 0;
                    }
                }

                //control for x-axis, it will work with rootscr
                if(mango.y == mango.maxHeight){
                    rootscr.mG = 1;
                } else {
                    rootscr.mG = 0;
                }

                if(rootscr.conN == 1 && rootscr.gResume == 0){
                    ay.pause();
                    ax.pause();
                    ry.pause();
                    rx.pause();
                    ri.pause();
                } else if(rootscr.gResume == 1 && rootscr.conN == 0) {
                    ay.resume();
                    ax.resume();
                    ry.resume();
                    rx.resume();
                    ri.resume();
                    rootscr.visR = 0;

                    if(mango.y < -20 && mango.opacity == 1){
                        rootmango.deep = 1;
                    } else if(mango.y < -20 && mango.opacity == 0){
                        rootmango.deep = 0;
                    }

                    if(mango.y > -10 && mango.opacity == 0){
                        mango.opacity = 1;
                        mango_1.visible = false;
                        mango_2.visible = false;
                        rootscr.mHit = 0;
                        rootscr.mangoS = 0;
                    } else if(mango.y > -10 && mango.opacity == 1 && rootmango.deep == 1){
                        rootmango.deep = 0;
                        rootscr.life = rootscr.life - 1;
                    }
                }
            }
        }
    }
}
