import QtQuick 1.1
import com.nokia.meego 1.0

Item {
    id: rootorange

    //cut the fruit - part[1]
    Image {
        id: orange_1
        source: "images/orange-h1.png"
        smooth: true
        visible: false
        anchors.bottom: orange.bottom
        anchors.right:orange.right
        anchors.rightMargin: Math.floor(Math.random()*30+30)

        NumberAnimation on rotation { id: rx; from: 0; to: 360; duration: Math.floor(Math.random()*3000+600); loops: Animation.Infinite }
    }

    //cut the fruit - part[2]
    Image {
        id: orange_2
        source: "images/orange-h2.png"
        smooth: true
        visible: false
        anchors.bottom: orange.bottom
        anchors.left:orange.left
        anchors.leftMargin: Math.floor(Math.random()*50+30)

        NumberAnimation on rotation { id: ry; from: 360; to: 0; duration: Math.floor(Math.random()*3000+600); loops: Animation.Infinite }
    }

    //main fruit
    Image {
        id: orange
        source: "images/orange.png"
        smooth: true

        NumberAnimation on rotation { id: ri; from: 0; to: 360; duration: Math.floor(Math.random()*1000+2700); loops: Animation.Infinite }

        //y-axis animation
        property int maxHeight: 230
        property int minHeight: -Math.floor(Math.random()*100+345)

        y: minHeight

        SequentialAnimation on y {
            id: ay
            loops: Animation.Infinite
            running: true

            NumberAnimation {
                from: orange.maxHeight; to: orange.minHeight
                easing.type: Easing.OutCubic; duration: 1300
            }

            NumberAnimation {
                from: orange.minHeight; to: orange.maxHeight
                easing.type: Easing.InCubic; duration: 1300
            }

            PauseAnimation { duration: 7000 }

        }

        //x-axis animation
        property int maxWidth: Math.floor(Math.random()*200-60)
        property int minWidth: Math.floor(Math.random()*200-60)

        x: minWidth

        SequentialAnimation on x {
            id: ax
            running: true
            loops: Animation.Infinite

            NumberAnimation {
                from: orange.maxWidth; to: orange.minWidth
                easing.type: Easing.OutCubic; duration: 1300
            }

            NumberAnimation {
                from: orange.minWidth; to: orange.minWidth*2-orange.maxWidth
                easing.type: Easing.InCubic; duration: 1300
            }

            PauseAnimation { duration: 7000 }

        }

    }

    Timer {
        id: theTimer
        interval: 1
        repeat: true
        running: true
        onTriggered: {
            rootscr.oY = orange.y;
            rootscr.oW = orange.width;
            rootscr.oH = orange.height;
            if(rootscr.orangeC == 1  && rootscr.gResume == 1 && rootscr.foxfive == 7){
                rootscr.orangeC = 0;
                orange.opacity = 0;
                orange_1.visible = true;
                orange_2.visible = true;
                rootscr.score = rootscr.score + 1;
                rootscr.oHit = 1;
            }
        }
    }

    property int deep: 0

       Timer {
        id: frameTimer
        interval: 1
        repeat: true
        running: true

        onTriggered: {

            if(rootscr.foxfive == 6){
                ay.stop();
                ax.stop();
                ry.stop();
                rx.stop();
                ri.stop();
                if(rootscr.foxfive == 6){
                    orange.y = orange.maxHeight;
                    orange_splash.opacity = 0;
                }
            } else if(rootscr.foxfive == 7){
                ay.start();
                ax.start();
                ry.start();
                rx.start();
                ri.start();
                orange_splash.opacity = 1;


                //for restart
                if(rootscr.reSTorange == 1){
                    ay.restart();
                    ax.restart();
                    ry.restart();
                    rx.restart();
                    ri.restart();
                    rootscr.reSTorange = 0;
                    //rootscr.score = 0;
                    rootscr.life = 12;
                    rootscr.foxfive = 6;
                    if(rootorange.deep == 1){
                        rootscr.life = rootscr.life + 1;
                        rootorange.deep = 0;
                    }
                }

                //control for x-axis, it will work with rootscr
                if(orange.y == orange.maxHeight){
                    rootscr.oG = 1;
                } else {
                    rootscr.oG = 0;
                }

                if(rootscr.conN == 1 && rootscr.gResume == 0){
                    ay.pause();
                    ax.pause();
                    ry.pause();
                    rx.pause();
                    ri.pause();
                } else if(rootscr.gResume == 1 && rootscr.conN == 0) {
                    ay.resume();
                    ax.resume();
                    ry.resume();
                    rx.resume();
                    ri.resume();
                    rootscr.visR = 0;

                    if(orange.y < -20 && orange.opacity == 1){
                        rootorange.deep = 1;
                    } else if(orange.y < -20 && orange.opacity == 0){
                        rootorange.deep = 0;
                    }

                    if(orange.y > -10 && orange.opacity == 0){
                        orange.opacity = 1;
                        orange_1.visible = false;
                        orange_2.visible = false;
                        rootscr.oHit = 0;
                        rootscr.orangeS = 0;
                    } else if(orange.y > -10 && orange.opacity == 1 && rootorange.deep == 1){
                        rootorange.deep = 0;
                        rootscr.life = rootscr.life - 1;
                    }
                }
            }
        }
    }
}
