import QtQuick 1.1
import com.nokia.meego 1.0

Item {
    id: rootpear

    //cut the fruit - part[1]
    Image {
        id: pear_1
        source: "images/pear-h1.png"
        smooth: true
        visible: false
        anchors.bottom: pear.bottom
        anchors.right:pear.right
        anchors.rightMargin: Math.floor(Math.random()*30+30)

        NumberAnimation on rotation { id: rx; from: 0; to: 360; duration: Math.floor(Math.random()*3000+600); loops: Animation.Infinite }
    }

    //cut the fruit - part[2]
    Image {
        id: pear_2
        source: "images/pear-h2.png"
        smooth: true
        visible: false
        anchors.bottom: pear.bottom
        anchors.left:pear.left
        anchors.leftMargin: Math.floor(Math.random()*50+30)

        NumberAnimation on rotation { id: ry; from: 360; to: 0; duration: Math.floor(Math.random()*3000+600); loops: Animation.Infinite }
    }

    //main fruit
    Image {
        id: pear
        source: "images/pear.png"
        smooth: true

        NumberAnimation on rotation { id: ri; from: 0; to: 360; duration: Math.floor(Math.random()*1000+2700); loops: Animation.Infinite }

        //y-axis animation
        property int maxHeight: 230
        property int minHeight: -Math.floor(Math.random()*100+345)

        y: minHeight

        SequentialAnimation on y {
            id: ay
            loops: Animation.Infinite
            running: true

            NumberAnimation {
                from: pear.maxHeight; to: pear.minHeight
                easing.type: Easing.OutCubic; duration: 1300
            }

            NumberAnimation {
                from: pear.minHeight; to: pear.maxHeight
                easing.type: Easing.InCubic; duration: 1300
            }

            PauseAnimation { duration: 9000 }

        }

        //x-axis animation
        property int maxWidth: Math.floor(Math.random()*200-60)
        property int minWidth: Math.floor(Math.random()*200-60)

        x: minWidth

        SequentialAnimation on x {
            id: ax
            running: true
            loops: Animation.Infinite

            NumberAnimation {
                from: pear.maxWidth; to: pear.minWidth
                easing.type: Easing.OutCubic; duration: 1300
            }

            NumberAnimation {
                from: pear.minWidth; to: pear.minWidth*2-pear.maxWidth
                easing.type: Easing.InCubic; duration: 1300
            }

            PauseAnimation { duration: 9000 }

        }

    }

    Timer {
        id: theTimer
        interval: 1
        repeat: true
        running: true
        onTriggered: {
            rootscr.pY = pear.y;
            rootscr.pW = pear.width;
            rootscr.pH = pear.height;
            if(rootscr.pearC == 1  && rootscr.gResume == 1 && rootscr.foxfour == 7){
                rootscr.pearC = 0;
                pear.opacity = 0;
                pear_1.visible = true;
                pear_2.visible = true;
                rootscr.score = rootscr.score + 1;
                rootscr.pHit = 1;
                rootscr.foxone = 7;
            }
        }
    }

    property int deep: 0

       Timer {
        id: frameTimer
        interval: 1
        repeat: true
        running: true

        onTriggered: {

            if(rootscr.foxfour == 6){
                ay.stop();
                ax.stop();
                ry.stop();
                rx.stop();
                ri.stop();
                if(rootscr.foxfour == 6){
                    pear.y = pear.maxHeight;
                    pear_splash.opacity = 0;
                }
            } else if(rootscr.foxfour == 7){
                ay.start();
                ax.start();
                ry.start();
                rx.start();
                ri.start();
                pear_splash.opacity = 1;


                //for restart
                if(rootscr.reSTpear == 1){

                    ay.restart();
                    ax.restart();
                    ry.restart();
                    rx.restart();
                    ri.restart();
                    rootscr.reSTpear = 0;
                    //rootscr.score = 0;
                    rootscr.life = 12;
                    if(rootpear.deep == 1){
                        rootscr.life = rootscr.life + 1;
                        rootpear.deep = 0;
                    }
                }

                //control for x-axis, it will work with rootscr
                if(pear.y == pear.maxHeight){
                    rootscr.pG = 1;
                } else {
                    rootscr.pG = 0;
                }

                if(rootscr.conN == 1 && rootscr.gResume == 0){
                    ay.pause();
                    ax.pause();
                    ry.pause();
                    rx.pause();
                    ri.pause();
                } else if(rootscr.gResume == 1 && rootscr.conN == 0) {
                    ay.resume();
                    ax.resume();
                    ry.resume();
                    rx.resume();
                    ri.resume();
                    rootscr.visR = 0;

                    if(pear.y < -20 && pear.opacity == 1){
                        rootpear.deep = 1;
                    } else if(pear.y < -20 && pear.opacity == 0){
                        rootpear.deep = 0;
                    }

                    if(pear.y > -10 && pear.opacity == 0){
                        pear.opacity = 1;
                        pear_1.visible = false;
                        pear_2.visible = false;
                        rootscr.pHit = 0;
                        rootscr.pearS = 0;
                    } else if(pear.y > -10 && pear.opacity == 1 && rootpear.deep == 1){
                        rootpear.deep = 0;
                        rootscr.life = rootscr.life - 1;
                    }
                }
            }
        }
    }
}
