import QtQuick 1.1
import com.nokia.meego 1.0

Item {
    id: rootpineapple

    //cut the fruit - part[1]
    Image {
        id: pineapple_1
        source: "images/pineapple-h1.png"
        smooth: true
        visible: false
        anchors.bottom: pineapple.bottom
        anchors.right:pineapple.right
        anchors.rightMargin: Math.floor(Math.random()*30+30)

        NumberAnimation on rotation { id: rx; from: 0; to: 360; duration: Math.floor(Math.random()*3000+600); loops: Animation.Infinite }
    }

    //cut the fruit - part[2]
    Image {
        id: pineapple_2
        source: "images/pineapple-h2.png"
        smooth: true
        visible: false
        anchors.bottom: pineapple.bottom
        anchors.left:pineapple.left
        anchors.leftMargin: Math.floor(Math.random()*50+30)

        NumberAnimation on rotation { id: ry; from: 360; to: 0; duration: Math.floor(Math.random()*3000+600); loops: Animation.Infinite }
    }

    //main fruit
    Image {
        id: pineapple
        source: "images/pineapple.png"
        smooth: true

        NumberAnimation on rotation { id: ri; from: 0; to: 360; duration: Math.floor(Math.random()*1000+2700); loops: Animation.Infinite }

        //y-axis animation
        property int maxHeight: 230
        property int minHeight: -Math.floor(Math.random()*100+345)

        y: minHeight

        SequentialAnimation on y {
            id: ay
            loops: Animation.Infinite
            running: true

            NumberAnimation {
                from: pineapple.maxHeight; to: pineapple.minHeight
                easing.type: Easing.OutCubic; duration: 1300
            }

            NumberAnimation {
                from: pineapple.minHeight; to: pineapple.maxHeight
                easing.type: Easing.InCubic; duration: 1300
            }

            PauseAnimation { duration: 4000 }

        }

        //x-axis animation
        property int maxWidth: Math.floor(Math.random()*200-60)
        property int minWidth: Math.floor(Math.random()*200-60)

        x: minWidth

        SequentialAnimation on x {
            id: ax
            running: true
            loops: Animation.Infinite

            NumberAnimation {
                from: pineapple.maxWidth; to: pineapple.minWidth
                easing.type: Easing.OutCubic; duration: 1300
            }

            NumberAnimation {
                from: pineapple.minWidth; to: pineapple.minWidth*2-pineapple.maxWidth
                easing.type: Easing.InCubic; duration: 1300
            }

            PauseAnimation { duration: 4000 }

        }

    }

    Timer {
        id: theTimer
        interval: 1
        repeat: true
        running: true
        onTriggered: {
            rootscr.ppY = pineapple.y;
            rootscr.ppW = pineapple.width;
            rootscr.ppH = pineapple.height;
            if(rootscr.pineappleC == 1  && rootscr.gResume == 1 && rootscr.foxthree == 7){
                rootscr.pineappleC = 0;
                pineapple.opacity = 0;
                pineapple_1.visible = true;
                pineapple_2.visible = true;
                rootscr.score = rootscr.score + 1;
                rootscr.ppHit = 1;
                rootscr.foxone = 7;
            }
        }
    }

    property int deep: 0

       Timer {
        id: frameTimer
        interval: 1
        repeat: true
        running: true

        onTriggered: {

            if(rootscr.foxthree == 6){
                ay.stop();
                ax.stop();
                ry.stop();
                rx.stop();
                ri.stop();
                if(rootscr.foxthree == 6){
                    pineapple.y = pineapple.maxHeight;
                    pineapple_splash.opacity = 0;
                }
            } else if(rootscr.foxthree == 7){
                ay.start();
                ax.start();
                ry.start();
                rx.start();
                ri.start();
                pineapple_splash.opacity = 1;


                //for restart
                if(rootscr.reSTpineapple == 1){

                    ay.restart();
                    ax.restart();
                    ry.restart();
                    rx.restart();
                    ri.restart();
                    rootscr.reSTpineapple = 0;
                    //rootscr.score = 0;
                    rootscr.life = 12;
                    if(rootpineapple.deep == 1){
                        rootscr.life = rootscr.life + 1;
                        rootpineapple.deep = 0;
                    }
                }

                //control for x-axis, it will work with rootscr
                if(pineapple.y == pineapple.maxHeight){
                    rootscr.ppG = 1;
                } else {
                    rootscr.ppG = 0;
                }

                if(rootscr.conN == 1 && rootscr.gResume == 0){
                    ay.pause();
                    ax.pause();
                    ry.pause();
                    rx.pause();
                    ri.pause();
                } else if(rootscr.gResume == 1 && rootscr.conN == 0) {
                    ay.resume();
                    ax.resume();
                    ry.resume();
                    rx.resume();
                    ri.resume();
                    rootscr.visR = 0;

                    if(pineapple.y < -20 && pineapple.opacity == 1){
                        rootpineapple.deep = 1;
                    } else if(pineapple.y < -20 && pineapple.opacity == 0){
                        rootpineapple.deep = 0;
                    }

                    if(pineapple.y > -10 && pineapple.opacity == 0){
                        pineapple.opacity = 1;
                        pineapple_1.visible = false;
                        pineapple_2.visible = false;
                        rootscr.ppHit = 0;
                        rootscr.pineappleS = 0;
                    } else if(pineapple.y > -10 && pineapple.opacity == 1 && rootpineapple.deep == 1){
                        rootpineapple.deep = 0;
                        rootscr.life = rootscr.life - 1;
                    }
                }
            }
        }
    }
}
