import QtQuick 1.1
import com.nokia.meego 1.0

Item {
    id: rootwatermelon

    //cut the fruit - part[1]
    Image {
        id: watermelon_1
        source: "images/watermelon-h1.png"
        smooth: true
        visible: false
        anchors.bottom: watermelon.bottom
        anchors.right:watermelon.right
        anchors.rightMargin: Math.floor(Math.random()*30+30)

        NumberAnimation on rotation { id: rx; from: 0; to: 360; duration: Math.floor(Math.random()*3000+600); loops: Animation.Infinite }
    }

    //cut the fruit - part[2]
    Image {
        id: watermelon_2
        source: "images/watermelon-h2.png"
        smooth: true
        visible: false
        anchors.bottom: watermelon.bottom
        anchors.left:watermelon.left
        anchors.leftMargin: Math.floor(Math.random()*50+30)

        NumberAnimation on rotation { id: ry; from: 360; to: 0; duration: Math.floor(Math.random()*3000+600); loops: Animation.Infinite }
    }

    //main fruit
    Image {
        id: watermelon
        source: "images/watermelon.png"
        smooth: true

        NumberAnimation on rotation { id: ri; from: 0; to: 360; duration: Math.floor(Math.random()*1000+2700); loops: Animation.Infinite }

        //y-axis animation
        property int maxHeight: 230
        property int minHeight: -Math.floor(Math.random()*100+345)

        y: minHeight

        SequentialAnimation on y {
            id: ay
            loops: Animation.Infinite
            running: true

            NumberAnimation {
                from: watermelon.maxHeight; to: watermelon.minHeight
                easing.type: Easing.OutCubic; duration: 1300
            }

            NumberAnimation {
                from: watermelon.minHeight; to: watermelon.maxHeight
                easing.type: Easing.InCubic; duration: 1300
            }

            PauseAnimation { duration: 3355 }

        }

        //x-axis animation
        property int maxWidth: Math.floor(Math.random()*200-60)
        property int minWidth: Math.floor(Math.random()*200-60)

        x: minWidth

        SequentialAnimation on x {
            id: ax
            running: true
            loops: Animation.Infinite

            NumberAnimation {
                from: watermelon.maxWidth; to: watermelon.minWidth
                easing.type: Easing.OutCubic; duration: 1300
            }

            NumberAnimation {
                from: watermelon.minWidth; to: watermelon.minWidth*2-watermelon.maxWidth
                easing.type: Easing.InCubic; duration: 1300
            }

            PauseAnimation { duration: 3355 }

        }

    }

    Timer {
        id: theTimer
        interval: 1
        repeat: true
        running: true
        onTriggered: {
            rootscr.wY = watermelon.y;
            rootscr.wW = watermelon.width;
            rootscr.wH = watermelon.height;
            if(rootscr.watermelonC == 1  && rootscr.gResume == 1 && rootscr.foxone == 7){
                rootscr.watermelonC = 0;
                watermelon.opacity = 0;
                watermelon_1.visible = true;
                watermelon_2.visible = true;
                rootscr.score = rootscr.score + 1;
                rootscr.wHit = 1;
                rootscr.foxtwo = 7;
            }
        }
    }

    property int deep: 0

       Timer {
        id: frameTimer
        interval: 1
        repeat: true
        running: true

        onTriggered: {

            if(rootscr.foxone == 6){
                ay.stop();
                ax.stop();
                ry.stop();
                rx.stop();
                ri.stop();
                //watermelon.visible = false;
                if(rootscr.foxone == 6){
                    watermelon.y = watermelon.maxHeight;
                    watermelon_splash.opacity = 0;
                }
            } else if(rootscr.foxone == 7){
                ay.start();
                ax.start();
                ry.start();
                rx.start();
                ri.start();
                watermelon_splash.opacity = 1;

                //for restart
                if(rootscr.reSTwatermelon == 1){

                    ay.restart();
                    ax.restart();
                    ry.restart();
                    rx.restart();
                    ri.restart();
                    rootscr.reSTwatermelon = 0;
                    //rootscr.score = 0;
                    rootscr.life = 12;
                    if(rootwatermelon.deep == 1){
                        rootscr.life = rootscr.life + 1;
                        rootwatermelon.deep = 0;
                    }
                }

                //control for x-axis, it will work with rootscr
                if(watermelon.y == watermelon.maxHeight){
                    rootscr.wG = 1;
                } else {
                    rootscr.wG = 0;
                }

                if(rootscr.conN == 1 && rootscr.gResume == 0){
                    ay.pause();
                    ax.pause();
                    ry.pause();
                    rx.pause();
                    ri.pause();
                } else if(rootscr.gResume == 1 && rootscr.conN == 0) {
                    ay.resume();
                    ax.resume();
                    ry.resume();
                    rx.resume();
                    ri.resume();
                    rootscr.visR = 0;

                    if(watermelon.y < -20 && watermelon.opacity == 1){
                        rootwatermelon.deep = 1;
                    } else if(watermelon.y < -20 && watermelon.opacity == 0){
                        rootwatermelon.deep = 0;
                    }

                    if(watermelon.y > -10 && watermelon.opacity == 0){
                        watermelon.opacity = 1;
                        watermelon_1.visible = false;
                        watermelon_2.visible = false;
                        rootscr.wHit = 0;
                        rootscr.watermelonS = 0;
                    } else if(watermelon.y > -10 && watermelon.opacity == 1 && rootwatermelon.deep == 1){
                        rootwatermelon.deep = 0;
                        rootscr.life = rootscr.life - 1;
                    }
                }
            }
        }
    }
}
