import QtQuick 1.1
import com.nokia.meego 1.0
import QtMultimediaKit 1.1

Item {
    id: rootscr
    width: 854
    height: 480

    property int conN: 0
    property bool active: Qt.application.active


    Connections {
            target: rootscr
            onActiveChanged: {
                if (Qt.application.active){
                    rootscr.conN = 0;
                    //it works!
                } else {
                    rootscr.conN = 1;
                    bestone.bestScoreFunc();
                    if(rootscr.newGP == 1) {
                        rootscr.visR = 1;
                        rootscr.gResume = 0;
                    }
                    //it works!
                }
            }
        }

    SoundEffect {
        id: fruit_sound
        source: "sounds/1.wav"
        loops: 1
        // repeats one
        }

    property int fox: 6
    property int foxone: 6
    property int foxtwo: 6
    property int foxthree: 6
    property int foxfour: 6
    property int foxfive: 6
    property int foxberry: 6
    property int foxgranade: 6

    Image {
        id: bg
        source: "images/bg.jpg"
        anchors.fill: parent
        smooth: true
    }

    Image {
        id: life_img
        source: "images/life.png"
        anchors.bottom: parent.bottom
        anchors.right: parent.right
        anchors.bottomMargin: 10
        anchors.rightMargin: 10
    }

    Text {
        id: life_txt
        anchors.right: life_img.left
        anchors.topMargin: 2
        anchors.rightMargin: 15
        anchors.top: life_img.top
        font.pixelSize: 30
        color: "white"
        font.bold: true
        text: rootscr.life
        onTextChanged: {
            if(rootscr.life <= 0 ){
                rootscr.life = 0;
                rootscr.score = 0;
                life_txt.visible = false;
                game_over.visible = true;
                game_over.opacity = 1;
                rootscr.levelT = 1;
                rootscr.level = 1;
                bestone.bestScoreFunc();
                rootscr.fox = 6;
                rootscr.foxone = 6;
                rootscr.foxtwo = 6;
                rootscr.foxthree = 6;
                rootscr.foxfour = 6;
                rootscr.foxfive = 6;
                rootscr.foxberry = 6;
                rootscr.foxgranade = 6;
            }
        }
    }

    property int score: 0
    property int life: 12

    Score {
        id: total_txt
        anchors.top: parent.top
        anchors.topMargin: 2
        anchors.left: parent.left
        anchors.leftMargin: 10
    }

    property int levelT: 1
    property int level: 1

    Text {
        id: levelTText
        text: "Level: "+rootscr.levelT
        anchors.left: total_txt.left
        anchors.bottom: bg.bottom
        anchors.bottomMargin: 5
        font.pixelSize: 25
        color: "white"
        font.weight: Font.Bold
    }

    property int bestScore: 0

    Text {
        id: best_txt
        anchors.top: total_txt.bottom
        anchors.topMargin: 2
        anchors.left: total_txt.left
        text: "Best: "
        font.pixelSize: 20
        color: "white"
        font.weight: Font.Bold
    }

    //saving bestScore
    Text {
        id: bestone
        text: ""
        anchors.left: best_txt.right
        anchors.top: best_txt.top
        font.pixelSize: 20
        color: "white"
        font.weight: Font.Bold

        Timer {
            id: bestTimer
            interval: 10
            running: true
            repeat: true
            onTriggered: {
                if(rootscr.score > rootscr.bestScore){
                    rootscr.bestScore = rootscr.score;
                }
                // level Timer
                if(score >= 50){
                    level = 2;
                    rootscr.foxberry = 7;
                } else if(score < 50){
                    level = 1;
                    rootscr.foxberry = 6;
                }
                //levelT Timer
                if(score < 50){
                    levelT = 1;
                    rootscr.foxgranade = 6;
                } else if(score >= 50 && score < 100){
                    levelT = 2;
                    rootscr.foxgranade = 6;
                } else if(score >= 100){
                    levelT = 3;
                    rootscr.foxgranade = 7;
                }
                //Dialog
                if(dialogT >= 50){
                    dialog.visible = false;
                    dialog.opacity = false;
                }
                //Restart Berry Granade
                if(rootscr.reST == 1 && level == 2){
                    rootscr.reSTberry = 1;
                } else if(level == 1){
                    rootscr.reSTberry = 0;
                }
                if(rootscr.reST == 1 && levelT == 3){
                    rootscr.reSTgranade = 1;
                } else if(levelT <= 2){
                    rootscr.reSTgranade = 0;
                }
            }
        }

        function bestScoreFunc() {
            var db = openDatabaseSync("High Score DB Maximum2", "1.0", "BestScore QML SQL!", 100000);
            db.transaction(
                function(tx) {
                    tx.executeSql('CREATE TABLE IF NOT EXISTS Bestscores(highscore TEXT)');
                    tx.executeSql('INSERT INTO Bestscores VALUES(?)', rootscr.bestScore);
                    var rs = tx.executeSql('SELECT * FROM Bestscores');
                    var r = "";
                    for(var i = 1; i < rs.rows.length; i++) {
                        i = i-1;
                        bestScore = rs.rows.item(i).highscore;
                        i = i+1;
                        if(rootscr.bestScore < rs.rows.item(i).highscore){
                            r = rs.rows.item(i).highscore;
                            dialogT = r;
                            i = i-1;
                        } else {
                            r = rs.rows.item(i).highscore;
                        }

                        i= i+1;
                    }
                    text = r;
                }
            )
        }
        Component.onCompleted: bestScoreFunc()
    }

    property int dialogT: 0

    //splashes

       Splashwatermelon {
            id: watermelon_splash
        }

       Splashpineapple {
            id: pineapple_splash
        }

       Splashpear {
            id: pear_splash
        }

        Splashorange {
            id: orange_splash
        }

        Splashmango {
            id: mango_splash
        }

        Splashlemon {
            id: lemon_splash
        }

        Splashkiwi {
            id: kiwi_splash
        }

        Splashbanana {
            id: banana_splash
        }

        Splashapple {
            id: apple_splash
        }

        Splashberry {
            id: berry_splash
        }

        Splashbomb {
            id: bomb_splash
        }

        Splashgranade {
            id: granade_splash
        }


        //Apple
        property int aG: 0 // if y at max deep VERY İMPORTANT!!
        property int aY: 0 // y-axis
        property int aHit: 0 // if cut
        property int aH // height of fruit
        property int aW // width of fruit

        Apple {
            id: apple
            anchors.bottom: parent.bottom
            anchors.left: parent.left
            anchors.bottomMargin: 10

            property int aN: Math.floor(Math.random()*600+20)

            anchors.leftMargin: aN

            Timer {
                id: appletimer
                interval: 1
                repeat: true
                running: true
                onTriggered: {
                    if(apple.aN < 200 && rootscr.aG == 1 ){
                        apple.aN = Math.floor(Math.random()*614+20);
                    } else if(apple.aN >= 200 && apple.aN < 300 && rootscr.aG == 1){
                        apple.aN = Math.floor(Math.random()*615+20);
                    } else if(apple.aN >= 300 && apple.aN < 500 && rootscr.aG == 1){
                        apple.aN = Math.floor(Math.random()*616+20);
                    } else if (apple.aN >= 500 && rootscr.aG == 1){
                        apple.aN = Math.floor(Math.random()*617+20);
                    }
                }
            }
        }

        //Watermelon
        property int wG: 0 // if y at max deep VERY İMPORTANT!!
        property int wY: 0 // y-axis
        property int wHit: 0 // if cut
        property int wH // height of fruit
        property int wW // width of fruit

        Watermelon {
            id: watermelon
            anchors.bottom: parent.bottom
            anchors.left: parent.left
            anchors.bottomMargin: 10

            property int wN: Math.floor(Math.random()*600+20)

            anchors.leftMargin: wN

            Timer {
                id: watermelontimer
                interval: 1
                repeat: true
                running: true
                onTriggered: {
                    if(watermelon.wN < 200 && rootscr.wG == 1 ){
                        watermelon.wN = Math.floor(Math.random()*604+21);
                    } else if(watermelon.wN >= 200 && watermelon.wN < 300 && rootscr.wG == 1){
                        watermelon.wN = Math.floor(Math.random()*613+22);
                    } else if(watermelon.wN >= 300 && watermelon.wN < 500 && rootscr.wG == 1){
                        watermelon.wN = Math.floor(Math.random()*611+25);
                    } else if (watermelon.wN >= 500 && rootscr.wG == 1){
                        watermelon.wN = Math.floor(Math.random()*618+23);
                    }
                }
            }
        }

        //Banana
        property int bG: 0 // if y at max deep VERY İMPORTANT!!
        property int bY: 0 // y-axis
        property int bHit: 0 // if cut
        property int bH // height of fruit
        property int bW // width of fruit

        Banana {
            id: banana
            anchors.bottom: parent.bottom
            anchors.left: parent.left
            anchors.bottomMargin: 10

            property int bN: Math.floor(Math.random()*600+20)

            anchors.leftMargin: bN

            Timer {
                id: bananatimer
                interval: 1
                repeat: true
                running: true
                onTriggered: {
                    if(banana.bN < 200 && rootscr.bG == 1 ){
                        banana.bN = Math.floor(Math.random()*610+20);
                    } else if(banana.bN >= 200 && banana.bN < 300 && rootscr.bG == 1){
                        banana.bN = Math.floor(Math.random()*611+20);
                    } else if(banana.bN >= 300 && banana.bN < 500 && rootscr.bG == 1){
                        banana.bN = Math.floor(Math.random()*612+20);
                    } else if (banana.bN >= 500 && rootscr.bG == 1){
                        banana.bN = Math.floor(Math.random()*613+20);
                    }
                }
            }
        }

        //Orange
        property int oG: 0 // if y at max deep VERY İMPORTANT!!
        property int oY: 0 // y-axis
        property int oHit: 0 // if cut
        property int oH // height of fruit
        property int oW // width of fruit

        Orange {
            id: orange
            anchors.bottom: parent.bottom
            anchors.left: parent.left
            anchors.bottomMargin: 10

            property int oN: Math.floor(Math.random()*600+20)

            anchors.leftMargin: oN

            Timer {
                id: orangetimer
                interval: 1
                repeat: true
                running: true
                onTriggered: {
                    if(orange.oN < 200 && rootscr.oG == 1 ){
                        orange.oN = Math.floor(Math.random()*606+20);
                    } else if(orange.oN >= 200 && orange.oN < 300 && rootscr.oG == 1){
                        orange.oN = Math.floor(Math.random()*607+20);
                    } else if(orange.oN >= 300 && orange.oN < 500 && rootscr.oG == 1){
                        orange.oN = Math.floor(Math.random()*608+20);
                    } else if (orange.oN >= 500 && rootscr.oG == 1){
                        orange.oN = Math.floor(Math.random()*609+20);
                    }
                }
            }
        }

        //Kiwi
        property int kG: 0 // if y at max deep VERY İMPORTANT!!
        property int kY: 0 // y-axis
        property int kHit: 0 // if cut
        property int kH // height of fruit
        property int kW // width of fruit

        Kiwi {
            id: kiwi
            anchors.bottom: parent.bottom
            anchors.left: parent.left
            anchors.bottomMargin: 10

            property int kN: Math.floor(Math.random()*600+20)

            anchors.leftMargin: kN

            Timer {
                id: kiwitimer
                interval: 1
                repeat: true
                running: true
                onTriggered: {
                    if(kiwi.kN < 200 && rootscr.kG == 1 ){
                        kiwi.kN = Math.floor(Math.random()*605+20);
                    } else if(kiwi.kN >= 200 && kiwi.kN < 300 && rootscr.kG == 1){
                        kiwi.kN = Math.floor(Math.random()*606+20);
                    } else if(kiwi.kN >= 300 && kiwi.kN < 500 && rootscr.kG == 1){
                        kiwi.kN = Math.floor(Math.random()*607+20);
                    } else if (kiwi.kN >= 500 && rootscr.kG == 1){
                        kiwi.kN = Math.floor(Math.random()*608+20);
                    }
                }
            }
        }

        //Lemon
        property int lG: 0 // if y at max deep VERY İMPORTANT!!
        property int lY: 0 // y-axis
        property int lHit: 0 // if cut
        property int lH // height of fruit
        property int lW // width of fruit

        Lemon {
            id: lemon
            anchors.bottom: parent.bottom
            anchors.left: parent.left
            anchors.bottomMargin: 10

            property int lN: Math.floor(Math.random()*600+20)

            anchors.leftMargin: lN

            Timer {
                id: lemontimer
                interval: 1
                repeat: true
                running: true
                onTriggered: {
                    if(lemon.lN < 200 && rootscr.lG == 1 ){
                        lemon.lN = Math.floor(Math.random()*604+20);
                    } else if(lemon.lN >= 200 && lemon.plN < 300 && rootscr.lG == 1){
                        lemon.lN = Math.floor(Math.random()*605+20);
                    } else if(lemon.lN >= 300 && lemon.lN < 500 && rootscr.lG == 1){
                        lemon.lN = Math.floor(Math.random()*606+20);
                    } else if (lemon.lN >= 500 && rootscr.lG == 1){
                        lemon.lN = Math.floor(Math.random()*607+20);
                    }
                }
            }
        }

        //Mango
        property int mG: 0 // if y at max deep VERY İMPORTANT!!
        property int mY: 0 // y-axis
        property int mHit: 0 // if cut
        property int mH // height of fruit
        property int mW // width of fruit

        Mango {
            id: mango
            anchors.bottom: parent.bottom
            anchors.left: parent.left
            anchors.bottomMargin: 10

            property int mN: Math.floor(Math.random()*600+20)

            anchors.leftMargin: mN

            Timer {
                id: mangotimer
                interval: 1
                repeat: true
                running: true
                onTriggered: {
                    if(mango.mN < 200 && rootscr.mG == 1 ){
                        mango.mN = Math.floor(Math.random()*603+20);
                    } else if(mango.mN >= 200 && mango.mN < 300 && rootscr.mG == 1){
                        mango.mN = Math.floor(Math.random()*604+20);
                    } else if(mango.mN >= 300 && mango.mN < 500 && rootscr.mG == 1){
                        mango.mN = Math.floor(Math.random()*605+20);
                    } else if (mango.mN >= 500 && rootscr.mG == 1){
                        mango.mN = Math.floor(Math.random()*606+20);
                    }
                }
            }
        }

        //Pear
        property int pG: 0 // if y at max deep VERY İMPORTANT!!
        property int pY: 0 // y-axis
        property int pHit: 0 // if cut
        property int pH // height of fruit
        property int pW // width of fruit

        Pear {
            id: pear
            anchors.bottom: parent.bottom
            anchors.left: parent.left
            anchors.bottomMargin: 10

            property int pN: Math.floor(Math.random()*600+20)

            anchors.leftMargin: pN

            Timer {
                id: peartimer
                interval: 1
                repeat: true
                running: true
                onTriggered: {
                    if(pear.pN < 200 && rootscr.pG == 1 ){
                        pear.pN = Math.floor(Math.random()*602+20);
                    } else if(pear.pN >= 200 && pear.pN < 300 && rootscr.pG == 1){
                        pear.pN = Math.floor(Math.random()*603+20);
                    } else if(pear.pN >= 300 && pear.pN < 500 && rootscr.pG == 1){
                        pear.pN = Math.floor(Math.random()*604+20);
                    } else if (pear.pN >= 500 && rootscr.pG == 1){
                        pear.pN = Math.floor(Math.random()*605+20);
                    }
                }
            }
        }

    //Pineapple
    property int ppG: 0 // if y at max deep VERY İMPORTANT!!
    property int ppY: 0 // y-axis
    property int ppHit: 0 // if cut
    property int ppH // height of fruit
    property int ppW // width of fruit

    Pineapple {
        id: pineapple
        anchors.bottom: parent.bottom
        anchors.left: parent.left
        anchors.bottomMargin: 10

        property int ppN: Math.floor(Math.random()*600+20)

        anchors.leftMargin: ppN

        Timer {
            id: pineappletimer
            interval: 1
            repeat: true
            running: true
            onTriggered: {
                if(pineapple.ppN < 200 && rootscr.ppG == 1 ){
                    pineapple.ppN = Math.floor(Math.random()*601+20);
                } else if(pineapple.ppN >= 200 && pineapple.ppN < 300 && rootscr.ppG == 1){
                    pineapple.ppN = Math.floor(Math.random()*602+20);
                } else if(pineapple.ppN >= 300 && pineapple.ppN < 500 && rootscr.ppG == 1){
                    pineapple.ppN = Math.floor(Math.random()*603+20);
                } else if (pineapple.ppN >= 500  && rootscr.ppG == 1){
                    pineapple.ppN = Math.floor(Math.random()*604+20);
                }
            }
        }
    }

    //Bomb
    property int bbG: 0 // if y at max deep VERY İMPORTANT!!
    property int bbY: 0 // y-axis
    property int bbHit: 0 // if cut
    property int bbH // height of fruit
    property int bbW // width of fruit

    Bomb {
        id: bomb
        anchors.bottom: parent.bottom
        anchors.left: parent.left
        anchors.bottomMargin: 10

        property int bbN: Math.floor(Math.random()*600+20)

        anchors.leftMargin: bbN

        Timer {
            id: bombtimer
            interval: 1
            repeat: true
            running: true
            onTriggered: {
                if(bomb.bbN < 200 && rootscr.bbG == 1 ){
                    bomb.bbN = Math.floor(Math.random()*541+20);
                } else if(bomb.bbN >= 200 && bomb.bbN < 300 && rootscr.bbG == 1){
                    bomb.bbN = Math.floor(Math.random()*561+20);
                } else if(bomb.bbN >= 300 && bomb.bbN < 500 && rootscr.bbG == 1){
                    bomb.bbN = Math.floor(Math.random()*431+20);
                } else if (bomb.bbN >= 500 && rootscr.bbG == 1){
                    bomb.bbN = Math.floor(Math.random()*501+30);
                }
            }
        }
    }

    //Granade
    property int gG: 0 // if y at max deep VERY İMPORTANT!!
    property int gY: 0 // y-axis
    property int gHit: 0 // if cut
    property int gH // height of fruit
    property int gW // width of fruit

    Granade {
        id: granade
        anchors.bottom: parent.bottom
        anchors.left: parent.left
        anchors.bottomMargin: 10

        property int gN: Math.floor(Math.random()*600+20)

        anchors.leftMargin: gN

        Timer {
            id: granadetimer
            interval: 1
            repeat: true
            running: true
            onTriggered: {
                if(granade.gN < 200 && rootscr.gG == 1 ){
                    granade.gN = Math.floor(Math.random()*541+20);
                } else if(granade.gN >= 200 && granade.gN < 300 && rootscr.gG == 1){
                    granade.gN = Math.floor(Math.random()*561+20);
                } else if(granade.gN >= 300 && granade.gN < 500 && rootscr.gG == 1){
                    granade.gN = Math.floor(Math.random()*431+20);
                } else if (granade.gN >= 500  && rootscr.gG == 1){
                    granade.gN = Math.floor(Math.random()*501+30);
                }
            }
        }
    }

    //Berry
    property int sG: 0 // if y at max deep VERY İMPORTANT!!
    property int sY: 0 // y-axis
    property int sHit: 0 // if cut
    property int sH // height of fruit
    property int sW // width of fruit

    Berry {
        id: berry
        anchors.bottom: parent.bottom
        anchors.left: parent.left
        anchors.bottomMargin: 10

        property int sN: Math.floor(Math.random()*600+20)

        anchors.leftMargin: sN

        Timer {
            id: berrytimer
            interval: 1
            repeat: true
            running: true
            onTriggered: {
                if(berry.sN < 200 && rootscr.sG == 1 ){
                    berry.sN = Math.floor(Math.random()*400+20);
                } else if(berry.sN >= 200 && berry.sN < 300 && rootscr.sG == 1){
                    berry.sN = Math.floor(Math.random()*410+20);
                } else if(berry.sN >= 300 && berry.sN < 500 && rootscr.sG == 1){
                    berry.sN = Math.floor(Math.random()*420+20);
                } else if (berry.sN >= 500 && rootscr.sG == 1){
                    berry.sN = Math.floor(Math.random()*430+20);
                }
                if(rootscr.sY <= -10){
                    berry.opacity = 1;
                } else {
                    berry.opacity = 0;
                }
            }
        }
    }

        // hit

    property int xx: -10
    property int yy: -10
    property int appleC: 0
    property int appleS: 0
    property int watermelonC: 0
    property int watermelonS: 0
    property int bananaC: 0
    property int bananaS: 0
    property int bombC: 0
    property int bombS: 0
    property int granadeC: 0
    property int granadeS: 0
    property int kiwiC: 0
    property int kiwiS: 0
    property int lemonC: 0
    property int lemonS: 0
    property int mangoC: 0
    property int mangoS: 0
    property int orangeC: 0
    property int orangeS: 0
    property int pearC: 0
    property int pearS: 0
    property int pineappleC: 0
    property int pineappleS: 0
    property int berryC: 0
    property int berryS: 0


    Rectangle {
        id: hitter
        width: bg.width
        height: bg.height
        opacity: 0.001
        anchors.horizontalCenter: bg.horizontalCenter
        anchors.verticalCenter: bg.verticalCenter

        MouseArea {
            anchors.fill: parent
            onMousePositionChanged:{
                xx = mouseX;
                yy = mouseY;
                // apple
                if(rootscr.xx > apple.aN+20 && rootscr.xx < apple.aN + rootscr.aW-10 && rootscr.yy < -rootscr.aY && rootscr.yy > -rootscr.yy - rootscr.aH-10 && rootscr.appleS == 0){
                    rootscr.appleC = 1;
                    rootscr.appleS = 1;
                }
                // watermelon
                if(rootscr.xx > watermelon.wN+20 && rootscr.xx < watermelon.wN + rootscr.wW-10 && rootscr.yy < -rootscr.wY && rootscr.yy > -rootscr.yy - rootscr.wH-10 && rootscr.watermelonS == 0){
                    rootscr.watermelonC = 1;
                    rootscr.watermelonS = 1;
                }
                //banana
                if(rootscr.xx >banana.bN+20 && rootscr.xx < banana.bN + rootscr.bW-10 && rootscr.yy < -rootscr.bY && rootscr.yy > -rootscr.yy - rootscr.bH-10 && rootscr.bananaS == 0){
                    rootscr.bananaC = 1;
                    rootscr.bananaS = 1;
                }
                // bomb
                if(rootscr.xx > bomb.bbN+20 && rootscr.xx < bomb.bbN + rootscr.bbW-10 && rootscr.yy < -rootscr.bbY-20 && rootscr.yy > -rootscr.yy - rootscr.bbH-10 && rootscr.bombS == 0){
                    rootscr.bombC = 1;
                    rootscr.bombS = 1;
                }
                // granade
                if(rootscr.xx > granade.gN+20 && rootscr.xx < granade.gN + rootscr.gW-10 && rootscr.yy < -rootscr.gY-20 && rootscr.yy > -rootscr.yy - rootscr.gH-10 && rootscr.granadeS == 0){
                    rootscr.granadeC = 1;
                    rootscr.granadeS = 1;
                }
                // kiwi
                if(rootscr.xx > kiwi.kN+20 && rootscr.xx < kiwi.kN + rootscr.kW-10 && rootscr.yy < -rootscr.kY && rootscr.yy > -rootscr.yy - rootscr.kH-10 && rootscr.kiwiS == 0){
                    rootscr.kiwiC = 1;
                    rootscr.kiwiS = 1;
                }
                // lemon
                if(rootscr.xx > lemon.lN+20 && rootscr.xx < lemon.lN + rootscr.lW-10 && rootscr.yy < -rootscr.lY && rootscr.yy > -rootscr.yy - rootscr.lH-10 && rootscr.lemonS == 0){
                    rootscr.lemonC = 1;
                    rootscr.lemonS = 1;
                }
                // mango
                if(rootscr.xx > mango.mN+20 && rootscr.xx < mango.mN + rootscr.mW-10 && rootscr.yy < -rootscr.mY && rootscr.yy > -rootscr.yy - rootscr.mH-10 && rootscr.mangoS == 0){
                    rootscr.mangoC = 1;
                    rootscr.mangoS = 1;
                }
                // orange
                if(rootscr.xx > orange.oN+20 && rootscr.xx < orange.oN + rootscr.oW-10 && rootscr.yy < -rootscr.oY && rootscr.yy > -rootscr.yy - rootscr.oH-10 && rootscr.orangeS == 0){
                    rootscr.orangeC = 1;
                    rootscr.orangeS = 1;
                }
                // pear
                if(rootscr.xx > pear.pN+20 && rootscr.xx < pear.pN + rootscr.pW-10 && rootscr.yy < -rootscr.pY && rootscr.yy > -rootscr.yy - rootscr.pH-10 && rootscr.pearS == 0){
                    rootscr.pearC = 1;
                    rootscr.pearS = 1;
                }
                // pineapple
                if(rootscr.xx > pineapple.ppN+20 && rootscr.xx < pineapple.ppN + rootscr.ppW-10 && rootscr.yy < -rootscr.ppY && rootscr.yy > -rootscr.yy - rootscr.ppH-10 && rootscr.pineappleS == 0){
                    rootscr.pineappleC = 1;
                    rootscr.pineappleS = 1;
                }
                // berry
                if(rootscr.xx > berry.sN+20 && rootscr.xx < berry.sN + rootscr.sW-10 && rootscr.yy < -rootscr.sY && rootscr.yy > -rootscr.yy - rootscr.sH-10 && rootscr.berryS == 0){
                    rootscr.berryC = 1;
                    rootscr.berryS = 1;
                }
            }
            onExited: {
                rootscr.xx = 1600;
                rootscr.yy = 1600;
                if(rootscr.soundCnt == 1){
                    fruit_sound.play();
                }
            }
        }

    }


    //sound open close
    property int soundCnt: 0

    Image {
        id: soundClosed
        source: "images/sclosed.png"
        anchors.top: menu.bottom
        anchors.topMargin: 10
        anchors.right: menu.right
        anchors.rightMargin: 10
    }

    Image {
        id: soundOpened
        source: "images/sopen.png"
        anchors.verticalCenter: soundClosed.verticalCenter
        anchors.horizontalCenter: soundClosed.horizontalCenter
        visible: false
    }

    Rectangle {
        id: soundRect
        width: 40
        height: 40
        anchors.verticalCenter: soundClosed.verticalCenter
        anchors.horizontalCenter: soundClosed.horizontalCenter
        color: "white"
        opacity: 0.001
        MouseArea{
            anchors.fill: parent
            onPressed: {
                if(soundCnt == 0 && rootscr.newGP == 1){
                    soundCnt = 1;
                    soundClosed.visible = false;
                    soundOpened.visible = true;
                } else {
                    soundCnt = 0;
                    soundClosed.visible = true;
                    soundOpened.visible = false;
                }
            }
        }
    }

    //Swipe open close
    property int swipeCnt: 0

    Image {
        id: swipeClosed
        source: "images/swipeoff.png"
        anchors.top: soundClosed.bottom
        anchors.topMargin: 20
        anchors.right: menu.right
        anchors.rightMargin: 10
        visible: false
    }

    Image {
        id: swipeOpened
        source: "images/swipeon.png"
        anchors.verticalCenter: swipeClosed.verticalCenter
        anchors.horizontalCenter: swipeClosed.horizontalCenter
    }

    Rectangle {
        id: swipeRect
        width: 40
        height: 40
        anchors.verticalCenter: swipeClosed.verticalCenter
        anchors.horizontalCenter: swipeClosed.horizontalCenter
        color: "white"
        opacity: 0.001
        MouseArea{
            anchors.fill: parent
            onPressed: {
                if(swipeCnt == 0 && rootscr.newGP == 1){
                    swipeCnt = 1;
                    swipeOpened.visible = false;
                    swipeClosed.visible = true;
                    screen.allowSwipe = false;
                } else {
                    swipeCnt = 0;
                    swipeOpened.visible = true;
                    swipeClosed.visible = false;
                    screen.allowSwipe = true;
                }
            }
        }
    }

    //all buttons about game

    Rectangle {
        id: menu_bg
        color: "white"
        opacity: 0
        width: 854
        height: 120
        anchors.verticalCenter: bg.verticalCenter
        anchors.horizontalCenter: bg.horizontalCenter
        visible: false

        Timer {
            id: rect_menu_timer
            interval: 1
            running: true
            repeat: true
            onTriggered: {
                onVisibleChanged: {
                    if(rootscr.visR == 1){
                        menu_bg.visible = true;
                        menu_bg.opacity = 0.7;
                    } else {
                        menu_bg.visible = false;
                        menu_bg.opacity = 0;
                        rootscr.gResume = 1;
                    }
                }
            }
        }
    }

    property int gResume: 1
    property int visR: 0
    property int newGP: 0 //new game pressed

    Image {
        id: game_resume
        source: "images/resume.png"
        smooth: true
        opacity: 0
        visible: false

        anchors.verticalCenter: bg.verticalCenter
        anchors.horizontalCenter: bg.horizontalCenter

        MouseArea{

            anchors.fill: parent

            onPressed: {
                //screen.allowSwipe = false;
                rootscr.gResume = 1;
                rootscr.visR = 0;
                rootscr.conN = 0; // try it for pause button
                if(rootscr.life <= 0){
                    rootscr.score = 0;
                    rootscr.reST = 1;
                    rootscr.visR = 0;
                    rootscr.reSTbanana = 1;
                    rootscr.reSTwatermelon = 1;
                    rootscr.reSTbomb = 1;
                    //rootscr.reSTgranade = 1;
                    rootscr.reSTkiwi = 1;
                    rootscr.reSTlemon = 1;
                    rootscr.reSTmango = 1;
                    rootscr.reSTorange = 1;
                    rootscr.reSTpear = 1;
                    rootscr.reSTpineapple = 1;
                    //rootscr.reSTberry = 1;
                    rootscr.conN = 0; // try it for pause button
                }
            }
        }

        Timer {
            id: resume_timer
            interval: 1
            running: true
            repeat: true
            onTriggered: {
                onVisibleChanged: {
                    if(rootscr.visR == 1){
                        game_resume.visible = true;
                        game_resume.opacity = 1;
                    } else {
                        game_resume.visible = false;
                        game_resume.opacity = 0;
                        rootscr.gResume = 1;
                    }
                }
            }
        }

    }

    property int reST: 0
    property int reSTbanana: 0
    property int reSTwatermelon: 0
    property int reSTorange: 0
    property int reSTkiwi: 0
    property int reSTlemon: 0
    property int reSTmango: 0
    property int reSTpear: 0
    property int reSTpineapple: 0
    property int reSTbomb: 0
    property int reSTgranade: 0
    property int reSTberry: 0

    Image {
        id: re_start
        source: "images/restart.png"
        smooth: true
        opacity: 0
        visible: false

        anchors.bottom: game_resume.bottom
        anchors.right: game_resume.left
        anchors.rightMargin: 20

        MouseArea {
            anchors.fill: parent
            onPressed: {
                //screen.allowSwipe = false;
                rootscr.score = 0;
                rootscr.reST = 1;
                rootscr.visR = 0;
                rootscr.reSTbanana = 1;
                rootscr.reSTwatermelon = 1;
                rootscr.reSTbomb = 1;
                //rootscr.reSTgranade = 1;
                rootscr.reSTkiwi = 1;
                rootscr.reSTlemon = 1;
                rootscr.reSTmango = 1;
                rootscr.reSTorange = 1;
                rootscr.reSTpear = 1;
                rootscr.reSTpineapple = 1;
                //rootscr.reSTberry = 1;
                rootscr.conN = 0; // try it for pause button
                rootscr.foxone = 6;
                rootscr.foxtwo = 6;
                rootscr.foxthree = 6;
                rootscr.foxfour = 6;
                rootscr.foxfive = 6;
                rootscr.foxgranade = 6;
                rootscr.foxberry = 6;
            }
        }

        Timer {
            id: restart_timer
            interval: 1
            running: true
            repeat: true
            onTriggered: {
                onVisibleChanged: {
                    if(rootscr.visR == 1){
                        re_start.visible = true;
                        re_start.opacity = 1;
                    } else {
                        re_start.visible = false;
                        re_start.opacity = 0;
                        rootscr.gResume = 1;
                    }
                }
            }
        }
    }

    Image {
        id: exit_all_game
        source: "images/exit.png"
        smooth: true
        opacity: 0
        visible: false

        anchors.bottom: game_resume.bottom
        anchors.left: game_resume.right
        anchors.leftMargin: 20

        MouseArea {
            anchors.fill: parent
            onPressed: {
                Qt.quit();
            }
        }

        Timer {
            id: exit_all_timer
            interval: 1
            running: true
            repeat: true
            onTriggered: {
                onVisibleChanged: {
                    if(rootscr.visR == 1){
                        exit_all_game.visible = true;
                        exit_all_game.opacity = 1;
                    } else {
                        exit_all_game.visible = false;
                        exit_all_game.opacity = 0;
                        rootscr.gResume = 1;
                    }
                }
            }
        }
    }

    //Menu - Paused
    Image {
        id: menu
        source: "images/paused.png"
        anchors.top: parent.top
        anchors.right: parent.right
        opacity: 1
            MouseArea {
                anchors.fill: parent
                onPressed: {
                    if(rootscr.newGP == 1) {
                        //screen.allowSwipe = true;
                        rootscr.conN = 1;
                        rootscr.visR = 1;
                        rootscr.gResume = 0;
                        bestone.bestScoreFunc();
                        if(game_over.visible = true){
                            game_over.visible = false;
                            game_over.opacity = 0;
                            life_txt.visible = true;
                            rootscr.fox = 7;
                            /*rootscr.foxone = 7;
                            rootscr.foxtwo = 7;
                            rootscr.foxthree = 7;
                            rootscr.foxfour = 7;
                            rootscr.foxfive = 7;*/
                        }
                }
            }
        }
    }

            property int aboutG: 0;

    // start game
    Item {
        id: start_game
        width: start_new.width
        height: start_new.height
        anchors.bottom: parent.bottom
        anchors.right: parent.right
        Image {
            id: start_new
            source: "images/start.jpg"
            smooth: true
        } 
        Rectangle {
            id: game_rect
            width: 210
            height: 200
            anchors.left: parent.left
            anchors.bottom: parent.bottom
            anchors.bottomMargin: 40
            anchors.leftMargin:60
            opacity: 0.001
            MouseArea{
                anchors.fill: parent
                onPressed: {
                    if(rootscr.foxCh == 1 && rootscr.aboutG == 0 && dialog.visible == 0){
                        start_new.opacity = 0;
                        rect_game_qt.opacity = 0;
                        game_rect.opacity = 0;
                        rootscr.fox = rootscr.fox + 1;
                        rootscr.newGP = 1;
                        about.opacity = 0;
                        bestone.bestScoreFunc();
                    }
                }
            }

        }



        Rectangle {
            id: rect_game_qt
            width: 170
            height: 200
            anchors.right: start_new.right
            anchors.bottom: start_new.bottom
            anchors.bottomMargin: 20
            anchors.rightMargin: 90
            opacity: 0.001
            MouseArea{
                anchors.fill: parent
                onPressed: {
                    if(rootscr.aboutG == 0 && rootscr.foxCh == 1 && dialog.visible == 0){
                        Qt.quit();
                    }
                }
            }
        }

        Rectangle {
            id: about
            width: 200
            height: 300
            anchors.verticalCenter: parent.verticalCenter
            anchors.horizontalCenter: parent.horizontalCenter
            opacity: 0.001
            MouseArea{
                anchors.fill: parent
                onPressed: {
                    if(rootscr.aboutG == 0 && rootscr.foxCh == 1 && rootscr.newGP == 0 && dialog.visible == 0 ){
                        rootscr.aboutG = 1;
                        about_image.visible = true;
                        about_image.opacity = 1;
                        about_rect_open.opacity = 0.001;
                    }
                }
            }
        }

        //About
        Image{
            id: about_image
            source: "images/about.jpg"
            smooth: true
            anchors.bottom: parent.bottom
            anchors.left: parent.left

            visible: false
            opacity: 0

            Rectangle {
                id: about_rect_open
                width: 200
                height: 300
                anchors.bottom: parent.bottom
                anchors.left: parent.left
                anchors.bottomMargin: 50
                anchors.leftMargin: 120
                opacity: 0.001

                MouseArea {
                    anchors.fill: parent
                    onPressed: {
                        if(rootscr.aboutG == 1 && rootscr.foxCh == 1 && rootscr.newGP == 0 && dialog.visible == 0){
                            about_image.visible = false;
                            about_image.opacity = 0;
                            rootscr.aboutG = 0;
                            about_rect_open.opacity = 0;
                        }
                    }
                }

            }
        }



    }


    Image {
        id: game_over
        source: "images/gameover.png"
        smooth: true
        anchors.bottom: parent.bottom
        anchors.right: parent.right
        visible: false
        opacity: 0
    }

    Image {
        id: dialog
        source: "images/dialog.png"
        smooth: true
        anchors.verticalCenter: parent.verticalCenter
        anchors.horizontalCenter: parent.horizontalCenter
        Rectangle {
            id: button_dialog
            height: 50
            width: 140
            anchors.bottom: parent.bottom
            anchors.bottomMargin: 10
            anchors.horizontalCenter: parent.horizontalCenter
            opacity: 0.001
            MouseArea {
                anchors.fill: parent
                onPressed: {
                    if(rootscr.foxCh == 1){
                        dialog.visible = 0;
                        dialog.opacity = 0;
                    }
                }
            }
        }
    }

    property int foxCh: 0

    Foxenon {
        id: fox_enon
        anchors.bottom: parent.bottom
        anchors.right: parent.right
    }
}
